Attribute VB_Name = "Module1"
Option Explicit

Public Type RASSTATS2000
    dwSize As Long
    dwBytesXmited As Long
    dwBytesRcved As Long
    dwFramesXmited As Long
    dwFramesRcved As Long
    dwCrcErr As Long
    dwTimeoutErr As Long
    dwAlignmentErr As Long
    dwHardwareOverrunErr As Long
    dwFramingErr As Long
    dwBufferOverrunErr As Long
    dwCompressionRatioIn As Long
    dwCompressionRatioOut As Long
    dwBps As Long
    dwConnectDuration As Long
End Type

Public Declare Function RasGetConnectionStatistics Lib "RasApi32.DLL" _
            (ByVal hRasConn As Long, _
            lpStatistics As RASSTATS2000) As Long

Public Declare Function RasGetLinkStatistics Lib "RasApi32.DLL" _
            (ByVal hRasConn As Long, _
            ByVal dwSubEntry As Long, _
            lpStatistics As RASSTATS2000) As Long
            
Public Declare Function RasEnumConnections Lib "RasApi32.DLL" _
        Alias "RasEnumConnectionsA" (lpRasCon As Any, lpcb As _
        Long, lpcConnections As Long) As Long
        
Public Declare Function RasGetConnectStatus Lib "RasApi32.DLL" _
        Alias "RasGetConnectStatusA" (ByVal hRasCon As Long, _
        lpStatus As Any) As Long

Public Const RAS_MaxEntryName = 256
Public Const RAS_MaxDeviceType = 16
Public Const RAS_MaxDeviceName = 32

Public Type RASType
  dwSize As Long
  hRasCon As Long
  szEntryName(RAS_MaxEntryName) As Byte
  szDeviceType(RAS_MaxDeviceType) As Byte
  szDeviceName(RAS_MaxDeviceName) As Byte
End Type

Public Type RASStatusType
  dwSize As Long
  RasConnState As Long
  dwError As Long
  szDeviceType(RAS_MaxDeviceType) As Byte
  szDeviceName(RAS_MaxDeviceName) As Byte
  szInBytes As Double
  syOutbytes As Double
End Type
Public Function ActiveConnection(s, r) As Boolean
Dim RAS(255) As RASType, RASStatus As RASStatusType
Dim lg&, lpcon&, Result&
Dim myStats As RASSTATS2000
Dim rtn As Long


RAS(0).dwSize = 412
lg = 256 * RAS(0).dwSize
Result = RasEnumConnections(RAS(0), lg, lpcon)

myStats.dwSize = LenB(myStats)
rtn = RasGetConnectionStatistics(RAS(0).hRasCon, myStats)

   
    If lpcon = 0 Then
'       Offline
        ActiveConnection = False
        Form1.Label2.Caption = 0
        Form1.Label1.Caption = 0
        
    Else
        RASStatus.dwSize = 160
        Result = RasGetConnectStatus(RAS(0).hRasCon, RASStatus)
        If RASStatus.RasConnState = &H2000 Then
'          Online
        ActiveConnection = True
        r = myStats.dwBytesRcved
        s = myStats.dwBytesXmited
           
        Else
'          DF-Einwahl oder -Trennen
        ActiveConnection = False
        Form1.Label2.Caption = 0
        Form1.Label1.Caption = 0
           
        End If
    End If
End Function
